bmm.em.alg=function(y,numobs,r,k,p,it,alpha,w,mu,sigma,eps,lik,pp,maxstep)

                     
{
likelihood=NULL
hh=0
ratio=1000

nq=length(pp$x)^r
py.s=matrix(0,numobs,k)
ps.y=matrix(0,numobs,k)
if (r>1) punteggi=sqrt(2)*z_ext(pp$x,r) else punteggi=matrix(sqrt(2)*pp$x,nq)
if (r>1) pesi=z_ext(pp$w,r)/sqrt(pi) else pesi=matrix(pp$w/sqrt(pi),nq)
E.z.sy=array(0,c(numobs,k,r))
E.zz.sy=array(0,c(numobs,k,r,r))
zex=array(0,c(nq,r,k))
 p.z.ys=array(0,c(nq,numobs,k))
  CC=array(0,c(r,r,numobs))

while ((hh < it) & (ratio > eps )) {
 hh<-hh+1
    
#### E step determino p(y|s=i)

for (i in 1:k) {Ci=chol(sigma[i,,])
                zex[,,i]=(punteggi%*%(Ci))+t(matrix(mu[i,],r,nq))
                ogg<- exp(alpha%*%t(cbind(1,zex[,,i])))
                ogg<-ifelse(is.infinite(ogg),1/eps,ogg)
                pi.greco=t(ogg/(1+ogg))
                pi.greco.g=array(pi.greco,c(nq,p,numobs))
                yg=aperm(array(y,c(numobs,p,nq)),c(3,2,1))
                py.zex=apply((pi.greco.g^yg)*((1-pi.greco.g)^(1-yg)),c(1,3),prod)
                py.s[,i]=apply(pesi,1,prod)%*%py.zex
                ### ora E.z.sy
                p.z.ys[,,i]=matrix(apply(pesi,1,prod),nq,numobs)*py.zex/t(matrix(py.s[,i],numobs,nq))
                E.z.sy[,i,]=t(t(zex[,,i])%*%p.z.ys[,,i])
                ### ora E.zz.sy
                temp=((matrix(zex[,,i],nrow=nq)))%o%t(matrix(zex[,,i],nrow=nq))
                temp=apply(temp,c(2,3),diag)
                temp=aperm(temp,c(2,3,1))
                for (l in 1:r) CC[l,,]=temp[l,,]%*%p.z.ys[,,i]
                E.zz.sy[,i,,]=aperm(CC,c(3,1,2))
                                }


p.y=py.s%*%w
Ez.y=matrix(0,numobs,r)
for (i in 1:k) {ps.y[,i]=w[i]*py.s[,i]/p.y
                Ez.y=Ez.y+matrix(ps.y[,i],numobs,r)*E.z.sy[,i,]
                }



#### M step stima w
w=colMeans(ps.y)

#### M step stima mu e sigma

temp1=matrix(0,r,r)
temp2=matrix(0,r,r)
temp3=matrix(0,r)
for (i in 1:k) {mu[i,]=colSums(matrix(ps.y[,i],numobs,r)*E.z.sy[,i,])/sum(ps.y[,i])
                sigma[i,,]=apply((array(ps.y[,i],c(numobs,r,r))*(E.zz.sy[,i,,]-aperm(array((mu[i,])%*%t(mu[i,]),c(r,r,numobs)),c(3,1,2)))),c(2,3),sum)/sum(ps.y[,i])
                temp1=temp1+w[i]*sigma[i,,]
                temp2=temp2+w[i]*(mu[i,]%*%t(mu[i,]))
                temp3=temp3+w[i]*mu[i,]}


for (j in 1:p) {#opt=optim(alpha[j,],fn=da.max,gr=NULL,method="BFGS",y=y[,j],zex=zex,k=k,ps.y=ps.y,p.z.ys=p.z.ys)
                opt=nlm(f=da.max,p=alpha[j,],stepmax=maxstep,y=y[,j],zex=zex,k=k,ps.y=ps.y,p.z.ys=p.z.ys)
                alpha[j,]=opt$estimate}



## correzione per l'identificabilit
var.z=temp1+temp2-temp3%*%t(temp3)
A<-(chol(var.z))
for (i in 1:k) {sigma[i,,]<-t(ginv(A))%*%sigma[i,,]%*%ginv(A)
                mu[i,]<-t(ginv(A))%*%mu[i,]
}

mu.tot=t(w)%*%mu
mu=mu-t(matrix(mu.tot,r,k))
alpha[,-1]=alpha[,-1]%*%t(A)



## vincolo degli zero
if (r>1) for (i in 2:r) alpha[1:(i-1),(i+1)]=0



######################################
temp<- sum(log(p.y))
likelihood<-c(likelihood,temp)
ratio<-(temp-lik)/abs(lik)
if (hh < 2) ratio=2*eps
if (any(abs(alpha>25))) ratio=eps
lik<-temp
                                    }
             
             
                  
            
                                    
out<-list(alpha=alpha,w=w,mu=mu,sigma=sigma,likelihood=likelihood,ps.y=ps.y,py.s=py.s,Ez.y=Ez.y,py=p.y)
return(out)
}


z_ext <-function(x,nfac){


## x    : punti di quadratura o pesi
## nfac : numero di fattori

nq <- length(x)                           # nr punti di quadratura
zx <- hcube(rep(nq,nfac))                 # calcola tutte le possibili disposizioni con ripetizione di 8 elementi presi a gruppi di 3
zx <- zx[,dim(zx)[2]:1]                   # zx contiene tutte le disposizioni "rovesciate"
z2 <- matrix(x[zx],dim(zx)[1],dim(zx)[2]) # in corrispondenza di ciascuna posizione vado a selezionare il nodo corrispondente. In questo modo
                                          # ottengo tutte le possibili combinazioni tra quadrature per ogni fattore latente.
return(z2)
}
 
 
 array.matrix<-function(A,B)
{
## A is an array of dimensions k1 x k2 x k3
## B is a matrix of dimensions k3 x k4
## returns D of dimensions k1 x k2 x k4

C<-A%o%B
D<-apply(C,c(1,2,5),diag)
D<-(apply(D,c(2,3,4),sum))
return(D)
}


da.max=function(alpha,y,zex,k,ps.y,p.z.ys)
{
nq=nrow(zex)
numobs=length(y)
temp=matrix(0,numobs)
for (i in 1:k) {
            den=log(1+exp(alpha%*%t(cbind(1,zex[,,i]))))
            den=(matrix(den,nq,numobs))
            num=t(t(t(y))%*%alpha%*%t(cbind(1,zex[,,i])))
            log.p.y.z=num-den
            temp=temp+ps.y[,i]*colSums(p.z.ys[,,i]*log.p.y.z)
            }
return(-sum(temp))
}



da.max2=function(alpha,y,zex,k,ps.y,p.z.ys)
{
nq=nrow(zex)
r=ncol(zex)
numobs=length(y)
temp=matrix(0,numobs)
temp2=matrix(0,numobs,r+1)
for (i in 1:k) {
            den=log(1+exp(alpha%*%t(cbind(1,zex[,,i]))))
            den=(matrix(den,nq,numobs))
            num=t(t(t(y))%*%alpha%*%t(cbind(1,zex[,,i])))
            log.p.y.z=num-den
            temp=temp+ps.y[,i]*colSums(p.z.ys[,,i]*log.p.y.z)
            
            ### per gradiente
            
            den=matrix(exp(alpha%*%t(cbind(1,zex[,,i]))),nq,r+1)*cbind(1,zex[,,i])/matrix(1+exp(alpha%*%t(cbind(1,zex[,,i]))),nq,r+1)
            den=aperm(array(den,c(nq,r+1,numobs)),c(1,3,2))
            num=aperm(y%o%(cbind(1,zex[,,i])),c(2,1,3))
            log.p.y.z=num-den
            temp2=temp2+matrix(ps.y[,i],numobs,r+1)*apply(array(p.z.ys[,,i],c(nq,numobs,r+1))*log.p.y.z,c(2,3),sum)
            
            }
res=-sum(temp)
attr(res, "gradient")=colSums(temp2)
return(res)
}


da.max.gr=function(alpha,y,zex,k,ps.y,p.z.ys)
{
nq=nrow(zex)
r=ncol(zex)
numobs=length(y)
temp=matrix(0,numobs,r+1)
for (i in 1:k) {
            den=matrix(exp(alpha%*%t(cbind(1,zex[,,i]))),nq,r+1)*cbind(1,zex[,,i])/matrix(1+exp(alpha%*%t(cbind(1,zex[,,i]))),nq,r+1)
            den=aperm(array(den,c(nq,r+1,numobs)),c(1,3,2))
            num=aperm(y%o%(cbind(1,zex[,,i])),c(2,1,3))
            log.p.y.z=num-den
            temp=temp+matrix(ps.y[,i],numobs,r+1)*apply(array(p.z.ys[,,i],c(nq,numobs,r+1))*log.p.y.z,c(2,3),sum)
            }
return(colSums(temp))
}
